Scriptname _QLG_MasterScript_ConsoleBinder_Form extends ObjectReference  
{ Single Fomr for Chain Class QLG made by Tobi, that is single Element and Should be handled by Data Class }
;===- Base Info. -===;
 ;Created: 2021-08-29
 ;Update: 2021-08-29
 ;Author: TobiPL			; Code based on Creative Mode Engine Code
 ;Unit: M.PC<1>
;===============================================;
;===- Var. setup -===========================================;
	;==- Share -==;						;
	; Core Elements ; - Do not change if You don't know how it works!...
	ObjectReference Property qNext Auto		; Reference to next Form
	ObjectReference Property qBack Auto		; Reference to Prev Form
	; Soft Elements ; - Change if You need to or You want to use it somewhere else
	String[] Property qMyCommand Auto		; Command that is stored here
	String Property qMyName Auto				; Binder Name ( for player use )
	Int[] Property qMyKey Auto				; Key that execute Command ( 0 -> Main / 1 -> Alt )
	Int Property qMyCommandAmt Auto			; Amount of Commands this Binder have Created
	Bool Property ImSilent Auto				; If True -> Send Console Log
	Bool Property ImTraced Auto				; If True -> Print Debug Trace to Papyrus Log
	Bool Property ImEnabled Auto				; If True -> Read Key input
	Bool Property ImGameOnly Auto			; If True -> Works only when all Menus are disabled
	; Personal variables ; - Those are not shared with other scripts
	Bool AltPressed
;===============================================;	
;===- Keyboard Script -=========================;
;***********************************************;
Event OnKeyUp( Int KeyID, Float qHold )
	If( KeyID == qMyKey[1] ) 
		AltPressed = false
	EndIf
	If( ( AltPressed ) || ( qMyKey[1] == 0 ) )
		If( ( Utility.IsInMenuMode() ) && ( ImGameOnly ))
			Return	; Im Game only, can't do shit in Menus :(...
		EndIf
		Int i = 0
		While( i < qMyCommandAmt )
			ConsoleUtil.ExecuteCommand( qMyCommand[i] )
			
			If( ImSilent )
				ConsoleUtil.PrintMessage( "::ConsoleBinder Executed: "+qMyCommand[i] )
			EndIf
			If( ImTraced )
				Debug.Trace( ":: ConsoleBinder Executed: "+qMyCommand[i] )
			EndIf
			i += 1
		EndWhile
	EndIf
EndEvent
;***********************************************;
Event OnKeyDown( Int KeyID )
	If( KeyID == qMyKey[1] )
		AltPressed = true
	EndIf
EndEvent
;***********************************************;
Function qChange( Int ID )
	If( ID == 0 )
		ImGameOnly = !ImGameOnly
	ElseIf( ID == 1 )
		ImTraced = !ImTraced
	ElseIf( ID == 2 )
		ImSilent = !ImSilent
	EndIf
EndFunction
;***********************************************;
Function qSwitch()
	If( ImEnabled )
		UnregisterForKey( qMyKey[0] )
		UnregisterForKey( qMyKey[1] )
		ImEnabled = false
			Else
		RegisterForKey( qMyKey[0] )
		RegisterForKey( qMyKey[1] )
		ImEnabled = true
	EndIf
EndFunction
;***********************************************;
Function qDeleteKey( Int ID )
	UnregisterForKey( qMyKey[ID] )
	qMyKey[ID] = 0
EndFunction
;***********************************************;
Function qUpdateKey( Int qKey, Int ID )
	If( qMyKey[ID] == 0 )
		qMyKey[ID] = qKey
		RegisterForKey( qMyKey[ID] )
			Else
		UnregisterForKey( qMyKey[ID] )
		qMyKey[ID] = qKey
		RegisterForKey( qMyKey[ID] )
	EndIf
EndFunction
;***********************************************;
Function qAddCommand( String NewCommand )
	qMyCommand = PapyrusUtil.PushString( qMyCommand, NewCommand )
	qMyCommandAmt += 1
EndFunction
;***********************************************;
Function qRemoveAllCommands()
	qMyCommand = new String [1]
	qMyCommand[0] = "Empty Command?"
	qMyCommandAmt = 1
EndFunction
;***********************************************;
;===============================================;	
;===- Constructor Script -======================;
Function qConstructor( Int qKey, String qCMD, String qName, ObjectReference _Next, ObjectReference _Back )
	qMyKey = new Int [2]
	qMyKey[0] = qKey
	qMyKey[1] = 0
	qMyCommand = new String [1]
	qMyCommand[0] = qCMD
	qMyCommandAmt = 1
	qMyName = qName
	qNext = _Next
	qBack = _Back
	qGet( _Next ).qBack = self 
	qGet( _Back ).qNext = self
	ImSilent = false
	ImTraced = false
	ImEnabled = true
	ImGameOnly = true
	AltPressed = false
	RegisterForKey( qMyKey[0] )
EndFunction
;===============================================;	
;===- Destructor Script -=======================;
Function qDestructor()					; Let's clear that Mess !...
	UnregisterForKey( qMyKey[0] )
	qGet( qNext ).qBack = qBack
	qGet( qBack ).qNext = qNext
EndFunction
;===============================================;	
_QLG_MasterScript_ConsoleBinder_Form Function qGet( ObjectReference qRef )
	Return qRef as _QLG_MasterScript_ConsoleBinder_Form
EndFunction
; TheEnd