Scriptname _QLG_MasterScript_ConsoleBinder_MCM extends SKI_ConfigBase  
{ Script for MCM for Console Binder Mod... Edit if You want :)... }
;===- Base Info. -===;
 ;Created: 2021-08-29
 ;Update: 2021-08-29
 ;Author: TobiPL
 ;Unit: M.PC<1>
;===============================================;
;===- Var. setup -===========================================;
	;==- Share -==;
	_QLG_MasterScript_ConsoleBinder_Main Property qMain Auto
	Int CommandStart
;===============================================;
;===- Main Script -=============================;
;***********************************************;
Event OnConfigInit()
	; Booo... empty :(...
EndEvent
;***********************************************;
Event OnPageReset( String qPage )
	CommandStart = 0 
	QL_Page_Binders()
EndEvent
;***********************************************;
Function QL_Page_Binders()
	SetTitleText("[T] Binders")
	AddHeaderOption("Binders Info: ")
	AddTextOption("Active Binders: ",qMain.qAmt)
	AddTextOptionST("_Binder_Create","Create Binder","")
	If( qMain.qAmt == 0 )
		AddTextOptionST("_Binder_Delete","Delete Binder","",1)
			Else
		AddTextOptionST("_Binder_Delete","Delete Binder","",0)
	EndIf
	
	Int b = qMain.qGetCmdAmt()
	If( qMain.qAmt == 0 )
		AddHeaderOption("Click Create Binder!...")
		AddHeaderOption("")
			Else
		AddHeaderOption("Binder Settings")
		AddHeaderOption("")
		AddMenuOptionST( "_Binder_Select", "Selected Binder: ", qMain.qGetName() )
		AddInputOptionST( "_Binder_SetName", "Set Name: ", qMain.qGetName() )
		AddKeyMapOptionST( "_Binder_Key_Main", "Set Key: ", qMain.qGetKey( 0 ) )
		AddKeyMapOptionST( "_Binder_Key_Alt", "Set Key: ", qMain.qGetKey( 1 ) )
		AddEmptyOption()
		AddEmptyOption()
		
		AddToggleOptionST( "_Binder_SetGameOnly", "Is Disabled in Menu?", qMain.qGetGame() )
		AddToggleOptionST( "_Binder_SetEnabled", "Is Enabled?", qMain.qGetEnabled() )
		AddToggleOptionST( "_Binder_SetCout", "Debug Logs", qMain.qGetLogs() )
		AddToggleOptionST( "_Binder_SetTrace", "Debug Trace", qMain.qGetTrace() )
		AddEmptyOption()
		AddEmptyOption()
		
		If( b >= 8 )
			AddTextOptionST("_Binder_Create_Command","Create Command","",1)
			Else
			AddTextOptionST("_Binder_Create_Command","Create Command","")
		EndIf
		AddTextOptionST("_Binder_Delete_Command","Delete All Commands","")
		Int i = 1
		CommandStart = AddInputOption("Set Command: ", qMain.qGetCommand( 0 ) )
		While( i < b )
			AddInputOption("Set Command: ", qMain.qGetCommand( i ) )
			i += 1
		EndWhile
	EndIf
EndFunction
;===============================================;
;***********************************************;
Event OnOptionInputOpen( Int ID )
	SetInputDialogStartText( "Enter Command" )
EndEvent
Event OnOptionInputAccept( Int ID, String NewCmd )
	qMain.qSetCommand( NewCmd, ID - CommandStart )
	ForcePageReset()
EndEvent
;===============================================;
;***********************************************;
State _Binder_Select
	Event OnMenuOpenST()
		SetMenuDialogOptions( qMain.qGetAllNames() )
	EndEvent
	Event OnMenuAcceptST( Int _Index )
		qMain.qSelectBinder( _Index )
		SetMenuOptionValueST( qMain.qGetName() )
		ForcePageReset()
	EndEvent
	Event OnHighlightST()
		SetInfoText("Click this Menu to select Binder, keep in mind that You should change Binder names... \n or its gonna be really hard for You to find Binder You look for \n by default all binders are called Default Binder")
	EndEvent
EndState
;===============================================;
;***********************************************;
State _Binder_SetName
	Event OnInputOpenST()
		SetInputDialogStartText( "Enter Name" )
	EndEvent
	Event OnInputAcceptST( String qInput )
		qMain.qSetName( qInput )
		SetInputOptionValueST( qMain.qGetName() )
		SetMenuOptionValueST( qMain.qGetName(), false,"_Binder_Select" )
	EndEvent
	Event OnHighlightST()
		SetInfoText("Change selected Binder name, it will be displayed in List and as Current name")
	EndEvent
EndState
;===============================================;
;***********************************************;
State _Binder_Key_Main
	Event OnKeyMapChangeST( Int _KeyID, String _IsConflict, String _ConflictName )
		qMain.qSetKey( _KeyID, 0 )
		SetKeyMapOptionValueST( _KeyID )
	EndEvent
	Event OnHighlightST()
		SetInfoText("Select key You want to use for this Binder \n You can use same key for multiple binders if You want!...")
	EndEvent
EndState
;===============================================;
;***********************************************;
State _Binder_Key_Alt
	Event OnKeyMapChangeST( Int _KeyID, String _IsConflict, String _ConflictName )
		qMain.qSetKey( _KeyID, 1 )
		SetKeyMapOptionValueST( _KeyID )
	EndEvent
	Event OnHighlightST()
		SetInfoText("Select Key as Your Alt key \n if its set to 0 ( ESC Button ) You use only Main Button \n You use combination of Two keys if Alt key is set!...")
	EndEvent
EndState
;===============================================;
;***********************************************;
State _Binder_Create
	Event OnSelectST()
		qMain.AddNew( 16 , "No Command" , "Default Name" )
		ForcePageReset()
	EndEvent
	Event OnHighlightST()
		SetInfoText("This will create new Command Binder and move view to it")
	EndEvent
EndState
;===============================================;
;***********************************************;
State _Binder_Delete
	Event OnSelectST()
		qMain.RemoveThis()
		ForcePageReset()
	EndEvent
	Event OnHighlightST()
		SetInfoText("This will delete Your current view Binder")
	EndEvent
EndState
;===============================================;
;***********************************************;
State _Binder_Create_Command
	Event OnSelectST()
		qMain.qAddCommand( "NewCommand" )
		ForcePageReset()
	EndEvent
	Event OnHighlightST()
		SetInfoText("This will Create new Command for this Binder \n All commands will be used in order they were created \n When You push Activate Key")
	EndEvent
EndState
;===============================================;
;***********************************************;
State _Binder_Delete_Command
	Event OnSelectST()
		qMain.qRemoveAllCmd()
		ForcePageReset()
	EndEvent
	Event OnHighlightST()
		SetInfoText("This will delete =ALL= Your Commands \n Sadly MCM is limited and i don't know any tricks to give second Action \n for Input Option... there is only One event i can use \n thats why only option is to delete all Commands and rewrite them if u need \n You can type QLG_RemoveMe as Command to remove it!...")
	EndEvent
EndState
;===============================================;
;***********************************************;
State _Binder_SetEnabled
	Event OnSelectST()
		qMain.qSetEnabled()
		SetToggleOptionValueST( qMain.qGetEnabled() )
	EndEvent
	Event OnHighlightST()
		SetInfoText("If You want this Binder be enabled, check this Box... \n If You want to disable Binder but not delete... uncheck... \n Easy right ? :D...")
	EndEvent
EndState
;===============================================;
;***********************************************;
State _Binder_SetGameOnly
	Event OnSelectST()
		qMain.qSetBool(0)
		SetToggleOptionValueST( qMain.qGetGame() )
	EndEvent
	Event OnHighlightST()
		SetInfoText("If this is selected, Command will be called only when all Game Menus are closed")
	EndEvent
EndState
;===============================================;
;***********************************************;
State _Binder_SetTrace
	Event OnSelectST()
		qMain.qSetBool(1)
		SetToggleOptionValueST( qMain.qGetTrace() )
	EndEvent
	Event OnHighlightST()
		SetInfoText("If this is selected, every time You use Command it will be printed to Papyrus Logs \n is not working if You have Disalbed Trace in Your INI files")
	EndEvent
EndState
;===============================================;
;***********************************************;
State _Binder_SetCout
	Event OnSelectST()
		qMain.qSetBool(2)
		SetToggleOptionValueST( qMain.qGetLogs() )
	EndEvent
	Event OnHighlightST()
		SetInfoText("If this is Selected, every time You use Command it will be printed to Console as Notification")
	EndEvent
EndState
; TheEnd