Scriptname _QLG_MasterScript_ConsoleBinder_Main extends ObjectReference  
{ Script that change everyting into Gold and Gems after time ^_^... }
;===- Base Info. -===;
 ;Created: 2021-08-17
 ;Update: 2021-08-17
 ;Author: TobiPL
 ;Unit: M.PC<1>
;===============================================;
;===- Var. setup -===========================================;
	;==- Share -==;							;
	ObjectReference Property qCurrent Auto		; Current selected Binder
	ObjectReference Property qTemp Auto			; Temp Binder ( to create new Form )
	ObjectReference Property qHelper Auto		; Help Binder ( used as PlaceAtMe reference )
	Int Property qAmt Auto						; Amount of Created Binders
	;*******************************************;
	FormList Property qData Auto
	; Data used for Scripts ;
	; [0] -> Base clear form ( for PlaceAtMe )
;===============================================;	
;===- Main Script -=============================;
;***********************************************;
Function AddNew( Int qKey, String qCMD, String qName )
	If( qAmt == 0 ) 
		qTemp = qHelper.PlaceAtMe( qData.GetAt( 0 ) ) as ObjectReference
		qGet( qTemp ).qConstructor( qKey, qCMD, qName, qTemp, qTemp )
		qCurrent = qTemp
	Else
		qTemp = qHelper.PlaceAtMe( qData.GetAt( 0 ) ) as ObjectReference
		qGet( qTemp ).qConstructor( qKey, qCMD, qName, qGet( qCurrent ).qNext, qCurrent )
		qCurrent = qTemp
	EndIf
	qAmt += 1
EndFunction
;***********************************************;
Function RemoveThis()
	If( qAmt > 1 )
		qTemp = qGet( qCurrent ).qNext
	EndIf
	qGet( qCurrent ).qDestructor()
	qCurrent.Delete()
	qCurrent = qTemp
	qAmt -= 1
EndFunction
;***********************************************;
Function qSelectBinder( Int qSkipIDs )
	Int i = 0
	While( i < qSkipIDs )
		qCurrent = qGet( qCurrent ).qNext
		i += 1
	EndWhile
EndFunction
;***********************************************;
String[] Function qGetAllNames()
	String[] qNames
	Int i = 0
	qTemp = qCurrent
	While( i < qAmt )
		qNames = PapyrusUtil.PushString( qNames, qGet( qTemp ).qMyName )
		qTemp = qGet( qTemp ).qNext
		i += 1 
	EndWhile
	Return qNames
EndFunction
;===============================================;	
;===- Getters Script -==========================;
;***********************************************;
String Function qGetName()
	Return qGet( qCurrent ).qMyName
EndFunction
;***********************************************;
String Function qGetCommand( Int ID )
	Return qGet( qCurrent ).qMyCommand[ID]
EndFunction
;***********************************************;
Int Function qGetKey( Int ID )
	Return qGet( qCurrent ).qMyKey[ID]
EndFunction
;***********************************************;
Bool Function qGetLogs()
	Return qGet( qCurrent ).ImSilent
EndFunction
;***********************************************;
Bool Function qGetTrace()
	Return qGet( qCurrent ).ImTraced
EndFunction
;***********************************************;
Bool Function qGetGame()
	Return qGet( qCurrent ).ImGameOnly
EndFunction
;***********************************************;
Bool Function qGetEnabled()
	Return qGet( qCurrent ).ImEnabled
EndFunction
;***********************************************;
Int Function qGetCmdAmt()
	Return qGet( qCUrrent ).qMyCommandAmt
EndFunction
;===============================================;	
;===- Setters Script -==========================;
;***********************************************;
Function qSetName( String _Name )
	qGet( qCurrent ).qMyName = _Name
EndFunction
;***********************************************;
Function qSetCommand( String _Command, Int ID )
	qGet( qCurrent ).qMyCommand[ID] = _Command
EndFunction
;***********************************************;
Function qSetKey( Int _Key, Int ID )
	qGet( qCurrent ).qUpdateKey( _Key, ID )
EndFunction
;***********************************************;
Function qSetBool( Int ID )
	qGet( qCurrent ).qChange( ID )
EndFunction
;***********************************************;
Function qSetEnabled()
	qGet( qCurrent ).qSwitch()
EndFunction
;===============================================;	
;===- Functions Script -========================;
;***********************************************;
_QLG_MasterScript_ConsoleBinder_Form Function qGet( ObjectReference qRef )
	Return qRef as _QLG_MasterScript_ConsoleBinder_Form
EndFunction
;***********************************************;
Function qAddCommand( String _Cmd )
	qGet( qCurrent ).qAddCommand( _Cmd )
EndFunction
;***********************************************;
Function qRemoveAllCmd()
	qGet( qCurrent ).qRemoveAllCommands()
EndFunction
; TheEnd